<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Media Server: Element.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Media Server
   &#160;<span id="projectnumber">1.0</span>
   </div>
   <div id="projectbrief">Simple MediaServer with effects and filters</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('Element_8hpp_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Element.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &quot;core/Bus.hpp&quot;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &quot;core/Pad.hpp&quot;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &quot;gst/gstelement.h&quot;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;functional&gt;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacegst.html">gst</a></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;{</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;    <span class="keyword">enum</span> State</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;    {</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;        VoidPending = 0,</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;        Null        = 1,</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;        Ready       = 2,</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        Paused      = 3,</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        Playing     = 4</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    };</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keyword">enum</span> StateChangeReturn</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    {</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        Failure   = 0,</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        Success   = 1,</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        Async     = 2,</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        NoPreroll = 3</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    };</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div>
<div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="classgst_1_1Element.html">   31</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classgst_1_1Element.html">Element</a> : <span class="keyword">public</span> <a class="code" href="classgst_1_1Object.html">Object</a></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    {</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;      <span class="keyword">private</span>:</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        GstElement *element_ref;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160; </div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;      <span class="keyword">protected</span>:</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <a class="code" href="classgst_1_1Element.html">Element</a>(GstElement *ref);</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160; </div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;      <span class="keyword">public</span>:</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        <span class="keyword">static</span> <a class="code" href="classgst_1_1Element.html">Element</a> create(GstElement *ref);</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160; </div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        GstElement *ref() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        <a class="code" href="classgst_1_1Element.html">Element</a> &amp;link(<a class="code" href="classgst_1_1Element.html">Element</a> &amp;destination);</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        <a class="code" href="classgst_1_1Element.html">Element</a> &amp;link_filtered(std::string src_pad_name, <a class="code" href="classgst_1_1Element.html">Element</a> &amp;destination, std::string dest_pad_name);</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        <a class="code" href="classgst_1_1Element.html">Element</a> &amp;unlink(<a class="code" href="classgst_1_1Element.html">Element</a> &amp;destination) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        StateChangeReturn set_state(State state) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        State state() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        State state_next() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        State state_pending() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        State state_target() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        <a class="code" href="classgst_1_1Pad.html">Pad</a> static_pad(std::string pad_name) <span class="keyword">const</span>;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160; </div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        <span class="comment">// void connect_pad_added(void (*f)(GstElement *, GstPad *, void *), void *t) const;</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <a class="code" href="classgst_1_1Bus.html">Bus</a> bus();</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    };</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;} <span class="comment">// namespace gst</span></div>
<div class="ttc" id="aclassgst_1_1Bus_html"><div class="ttname"><a href="classgst_1_1Bus.html">gst::Bus</a></div><div class="ttdef"><b>Definition:</b> Bus.hpp:12</div></div>
<div class="ttc" id="aclassgst_1_1Element_html"><div class="ttname"><a href="classgst_1_1Element.html">gst::Element</a></div><div class="ttdoc">C++ Wrapper around.</div><div class="ttdef"><b>Definition:</b> Element.hpp:32</div></div>
<div class="ttc" id="aclassgst_1_1Object_html"><div class="ttname"><a href="classgst_1_1Object.html">gst::Object</a></div><div class="ttdoc">C++ Wrapper around GstObject meant to be used in harmony with the other elements only provides virtua...</div><div class="ttdef"><b>Definition:</b> Object.hpp:13</div></div>
<div class="ttc" id="aclassgst_1_1Pad_html"><div class="ttname"><a href="classgst_1_1Pad.html">gst::Pad</a></div><div class="ttdef"><b>Definition:</b> Pad.hpp:27</div></div>
<div class="ttc" id="anamespacegst_html"><div class="ttname"><a href="namespacegst.html">gst</a></div><div class="ttdoc">Namespace for all GStreamer an GLib Wrappers.</div><div class="ttdef"><b>Definition:</b> Bin.hpp:7</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_a7bb9b575703809b9fbb7ad7f723668f.html">local_app</a></li><li class="navelem"><a class="el" href="dir_81b007610a59bc1f4a5ed448a6168bbb.html">media_framework</a></li><li class="navelem"><a class="el" href="dir_2216667e0452c61c00f98e2752b3a9f2.html">gstreamer-cpp</a></li><li class="navelem"><a class="el" href="dir_4e35b9dc1e034d94f28a0525077dc4f9.html">include</a></li><li class="navelem"><a class="el" href="dir_a59ae0337ddcda0e5781617847aabb7d.html">core</a></li><li class="navelem"><b>Element.hpp</b></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1 </li>
  </ul>
</div>
</body>
</html>
